GDAL

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
OGRUnionLayer Class Reference
Inheritance diagram for OGRUnionLayer:

## Public Member Functions
| OGRUnionLayer (const char *pszName, int nSrcLayers, OGRLayer **papoSrcLayers, int bTakeLayerOwnership)
void | SetFields (FieldUnionStrategy eFieldStrategy, int nFields, OGRFieldDefn **papoFields, int nGeomFields, OGRUnionLayerGeomFieldDefn **papoGeomFields)
void | SetSourceLayerFieldName (const char *pszSourceLayerFieldName)
void | SetPreserveSrcFID (int bPreserveSrcFID)
void | SetFeatureCount (int nFeatureCount)
virtual const char * | GetName ()
| Return the layer name. More...
virtual OGRwkbGeometryType | GetGeomType ()
| Return the layer geometry type. More...
virtual void | ResetReading ()
| Reset feature reading to start on the first feature. More...
virtual OGRFeature * | GetNextFeature ()
| Fetch the next available feature from this layer. More...
virtual OGRFeature * | GetFeature (GIntBig nFeatureId)
| Fetch a feature by its identifier. More...
virtual OGRErr | ICreateFeature (OGRFeature *poFeature)
| Create and write a new feature within a layer. More...
virtual OGRErr | ISetFeature (OGRFeature *poFeature)
| Rewrite an existing feature. More...
virtual OGRFeatureDefn * | GetLayerDefn ()
| Fetch the schema information for this layer. More...
virtual OGRSpatialReference * | GetSpatialRef ()
| Fetch the spatial reference system for this layer. More...
virtual GIntBig | GetFeatureCount (int)
| Fetch the feature count in this layer. More...
virtual OGRErr | SetAttributeFilter (const char *)
| Set a new attribute query. More...
virtual int | TestCapability (const char *)
| Test if this layer supported the named capability. More...
virtual OGRErr | GetExtent (int iGeomField, OGREnvelope *psExtent, int bForce=TRUE)
| Fetch the extent of this layer, on the specified geometry field. More...
virtual OGRErr | GetExtent (OGREnvelope *psExtent, int bForce)
| Fetch the extent of this layer. More...
virtual void | SetSpatialFilter (OGRGeometry *poGeomIn)
| Set a new spatial filter. More...
virtual void | SetSpatialFilter (int iGeomField, OGRGeometry *)
| Set a new spatial filter. More...
virtual OGRErr | SetIgnoredFields (const char **papszFields)
| Set which fields can be omitted when retrieving features from the layer. More...
virtual OGRErr | SyncToDisk ()
| Flush pending changes to disk. More...
Public Member Functions inherited from OGRLayer
virtual OGRGeometry * | GetSpatialFilter ()
| This method returns the current spatial filter for this layer. More...
virtual void | SetSpatialFilterRect (double dfMinX, double dfMinY, double dfMaxX, double dfMaxY)
| Set a new rectangular spatial filter. More...
virtual void | SetSpatialFilterRect (int iGeomField, double dfMinX, double dfMinY, double dfMaxX, double dfMaxY)
| Set a new rectangular spatial filter. More...
virtual OGRErr | SetNextByIndex (GIntBig nIndex)
| Move read cursor to the nIndex'th feature in the current resultset. More...
OGRErr | SetFeature (OGRFeature *poFeature) CPL_WARN_UNUSED_RESULT
| Rewrite an existing feature. More...
OGRErr | CreateFeature (OGRFeature *poFeature) CPL_WARN_UNUSED_RESULT
| Create and write a new feature within a layer. More...
virtual OGRErr | DeleteFeature (GIntBig nFID) CPL_WARN_UNUSED_RESULT
| Delete feature from layer. More...
virtual int | FindFieldIndex (const char *pszFieldName, int bExactMatch)
| Find the index of field in the layer. More...
virtual OGRErr | CreateField (OGRFieldDefn *poField, int bApproxOK=TRUE)
| Create a new field on a layer. More...
virtual OGRErr | DeleteField (int iField)
| Delete an existing field on a layer. More...
virtual OGRErr | ReorderFields (int *panMap)
| Reorder all the fields of a layer. More...
virtual OGRErr | AlterFieldDefn (int iField, OGRFieldDefn *poNewFieldDefn, int nFlagsIn)
| Alter the definition of an existing field on a layer. More...
virtual OGRErr | CreateGeomField (OGRGeomFieldDefn *poField, int bApproxOK=TRUE)
| Create a new geometry field on a layer. More...
virtual OGRStyleTable * | GetStyleTable ()
| Returns layer style table. More...
virtual void | SetStyleTableDirectly (OGRStyleTable *poStyleTable)
| Set layer style table. More...
virtual void | SetStyleTable (OGRStyleTable *poStyleTable)
| Set layer style table. More...
virtual OGRErr | StartTransaction () CPL_WARN_UNUSED_RESULT
virtual OGRErr | CommitTransaction () CPL_WARN_UNUSED_RESULT
virtual OGRErr | RollbackTransaction ()
virtual const char * | GetFIDColumn ()
| This method returns the name of the underlying database column being used as the FID column, or "" if not supported. More...
virtual const char * | GetGeometryColumn ()
| This method returns the name of the underlying database column being used as the geometry column, or "" if not supported. More...
OGRErr | Intersection (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=NULL, GDALProgressFunc pfnProgress=NULL, void *pProgressArg=NULL)
| Intersection of two layers. More...
OGRErr | Union (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=NULL, GDALProgressFunc pfnProgress=NULL, void *pProgressArg=NULL)
| Union of two layers. More...
OGRErr | SymDifference (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions, GDALProgressFunc pfnProgress, void *pProgressArg)
| Symmetrical difference of two layers. More...
OGRErr | Identity (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=NULL, GDALProgressFunc pfnProgress=NULL, void *pProgressArg=NULL)
| Identify the features of this layer with the ones from the identity layer. More...
OGRErr | Update (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=NULL, GDALProgressFunc pfnProgress=NULL, void *pProgressArg=NULL)
| Update this layer with features from the update layer. More...
OGRErr | Clip (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=NULL, GDALProgressFunc pfnProgress=NULL, void *pProgressArg=NULL)
| Clip off areas that are not covered by the method layer. More...
OGRErr | Erase (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=NULL, GDALProgressFunc pfnProgress=NULL, void *pProgressArg=NULL)
| Remove areas that are covered by the method layer. More...
int | Reference ()
| Increment layer reference count. More...
int | Dereference ()
| Decrement layer reference count. More...
int | GetRefCount () const
| Fetch reference count. More...
GIntBig | GetFeaturesRead ()
OGRErr | ReorderField (int iOldFieldPos, int iNewFieldPos)
| Reorder an existing field on a layer. More...
int | AttributeFilterEvaluationNeedsGeometry ()
OGRErr | InitializeIndexSupport (const char *)
OGRLayerAttrIndex * | GetIndex ()
Public Member Functions inherited from GDALMajorObject
int | GetMOFlags () const
void | SetMOFlags (int nFlagsIn)
virtual const char * | GetDescription () const
| Fetch object description. More...
virtual void | SetDescription (const char *)
| Set object description. More...
virtual char ** | GetMetadataDomainList ()
| Fetch list of metadata domains. More...
virtual char ** | GetMetadata (const char *pszDomain="")
| Fetch metadata. More...
virtual CPLErr | SetMetadata (char **papszMetadata, const char *pszDomain="")
| Set metadata. More...
virtual const char * | GetMetadataItem (const char *pszName, const char *pszDomain="")
| Fetch single metadata item. More...
virtual CPLErr | SetMetadataItem (const char *pszName, const char *pszValue, const char *pszDomain="")
| Set single metadata item. More...

## Protected Member Functions
void | AutoWarpLayerIfNecessary (int iSubLayer)
OGRFeature * | TranslateFromSrcLayer (OGRFeature *poSrcFeature)
void | ApplyAttributeFilterToSrcLayer (int iSubLayer)
int | GetAttrFilterPassThroughValue ()
void | ConfigureActiveLayer ()
void | SetSpatialFilterToSourceLayer (OGRLayer *poSrcLayer)
Protected Member Functions inherited from OGRLayer
int | FilterGeometry (OGRGeometry *)
int | InstallFilter (OGRGeometry *)
OGRErr | GetExtentInternal (int iGeomField, OGREnvelope *psExtent, int bForce)
Protected Member Functions inherited from GDALMajorObject
char ** | BuildMetadataDomainList (char **papszList, int bCheckNonEmpty,...) CPL_NULL_TERMINATED
| Helper function for custom implementations of GetMetadataDomainList() More...

## Protected Attributes
CPLString | osName
int | nSrcLayers
OGRLayer ** | papoSrcLayers
int | bHasLayerOwnership
OGRFeatureDefn * | poFeatureDefn
int | nFields
OGRFieldDefn ** | papoFields
int | nGeomFields
OGRUnionLayerGeomFieldDefn ** | papoGeomFields
FieldUnionStrategy | eFieldStrategy
CPLString | osSourceLayerFieldName
int | bPreserveSrcFID
GIntBig | nFeatureCount
int | iCurLayer
char * | pszAttributeFilter
int | nNextFID
int * | panMap
char ** | papszIgnoredFields
int | bAttrFilterPassThroughValue
int * | pabModifiedLayers
int * | pabCheckIfAutoWrap
OGRSpatialReference * | poGlobalSRS
Protected Attributes inherited from OGRLayer
int | m_bFilterIsEnvelope
OGRGeometry * | m_poFilterGeom
OGRPreparedGeometry * | m_pPreparedFilterGeom
OGREnvelope | m_sFilterEnvelope
int | m_iGeomFieldFilter
OGRStyleTable * | m_poStyleTable
OGRFeatureQuery * | m_poAttrQuery
char * | m_pszAttrQueryString
OGRLayerAttrIndex * | m_poAttrIndex
int | m_nRefCount
GIntBig | m_nFeaturesRead
Protected Attributes inherited from GDALMajorObject
int | nFlags
CPLString | sDescription
GDALMultiDomainMetadata | oMDMD

## Member Function Documentation

OGRErr OGRUnionLayer::GetExtent | ( | int | iGeomField,
|  | OGREnvelope * | psExtent,
|  | int | bForce = `TRUE`
| ) |  |
| virtual

Fetch the extent of this layer, on the specified geometry field.

Returns the extent (MBR) of the data in the layer. If bForce is FALSE, and it would be expensive to establish the extent then OGRERR_FAILURE will be returned indicating that the extent isn't know. If bForce is TRUE then some implementations will actually scan the entire layer once to compute the MBR of all the features in the layer.

Depending on the drivers, the returned extent may or may not take the spatial filter into account. So it is safer to call GetExtent() without setting a spatial filter.

Layers without any geometry may return OGRERR_FAILURE just indicating that no meaningful extents could be collected.

Note that some implementations of this method may alter the read cursor of the layer.

Note to driver implementer: if you implement GetExtent(int,OGREnvelope*,int), you must also implement GetExtent(OGREnvelope*, int) to make it call GetExtent(0,OGREnvelope*,int).

This method is the same as the C function OGR_L_GetExtentEx().

Parameters

  iGeomField | the index of the geometry field on which to compute the extent.
  psExtent | the structure in which the extent value will be returned.
  bForce | Flag indicating whether the extent should be computed even if it is expensive.

Returns
  OGRERR_NONE on success, OGRERR_FAILURE if extent not known.

Reimplemented from OGRLayer.

OGRErr OGRUnionLayer::GetExtent | ( | OGREnvelope * | psExtent,
|  | int | bForce
| ) |  |
| virtual

Fetch the extent of this layer.

Returns the extent (MBR) of the data in the layer. If bForce is FALSE, and it would be expensive to establish the extent then OGRERR_FAILURE will be returned indicating that the extent isn't know. If bForce is TRUE then some implementations will actually scan the entire layer once to compute the MBR of all the features in the layer.

Depending on the drivers, the returned extent may or may not take the spatial filter into account. So it is safer to call GetExtent() without setting a spatial filter.

Layers without any geometry may return OGRERR_FAILURE just indicating that no meaningful extents could be collected.

Note that some implementations of this method may alter the read cursor of the layer.

This method is the same as the C function OGR_L_GetExtent().

Parameters

  psExtent | the structure in which the extent value will be returned.
  bForce | Flag indicating whether the extent should be computed even if it is expensive.

Returns
  OGRERR_NONE on success, OGRERR_FAILURE if extent not known.

Reimplemented from OGRLayer.

OGRFeature * OGRUnionLayer::GetFeature | ( | GIntBig | nFID | ) |
| virtual

Fetch a feature by its identifier.

This function will attempt to read the identified feature. The nFID value cannot be OGRNullFID. Success or failure of this operation is unaffected by the spatial or attribute filters (and specialized implementations in drivers should make sure that they do not take into account spatial or attribute filters).

If this method returns a non-NULL feature, it is guaranteed that its feature id (OGRFeature::GetFID()) will be the same as nFID.

Use OGRLayer::TestCapability(OLCRandomRead) to establish if this layer supports efficient random access reading via GetFeature(); however, the call should always work if the feature exists as a fallback implementation just scans all the features in the layer looking for the desired feature.

Sequential reads (with GetNextFeature()) are generally considered interrupted by a GetFeature() call.

The returned feature should be free with OGRFeature::DestroyFeature().

This method is the same as the C function OGR_L_GetFeature().

Parameters

  nFID | the feature id of the feature to read.

Returns
  a feature now owned by the caller, or NULL on failure.

Reimplemented from OGRLayer.

GIntBig OGRUnionLayer::GetFeatureCount | ( | int | bForce | ) |
| virtual

Fetch the feature count in this layer.

Returns the number of features in the layer. For dynamic databases the count may not be exact. If bForce is FALSE, and it would be expensive to establish the feature count a value of -1 may be returned indicating that the count isn't know. If bForce is TRUE some implementations will actually scan the entire layer once to count objects.

The returned count takes the spatial filter into account.

Note that some implementations of this method may alter the read cursor of the layer.

This method is the same as the C function OGR_L_GetFeatureCount().

Note: since GDAL 2.0, this method returns a GIntBig (previously a int)

Parameters

  bForce | Flag indicating whether the count should be computed even if it is expensive.

Returns
  feature count, -1 if count not known.

Reimplemented from OGRLayer.

OGRwkbGeometryType OGRUnionLayer::GetGeomType | ( |  | ) |
| virtual

Return the layer geometry type.

This returns the same result as GetLayerDefn()->OGRFeatureDefn::GetGeomType(), but for a few drivers, calling GetGeomType() directly can avoid lengthy layer definition initialization.

For layers with multiple geometry fields, this method only returns the geometry type of the first geometry column. For other columns, use GetLayerDefn()->OGRFeatureDefn::GetGeomFieldDefn(i)->GetType(). For layers without any geometry field, this method returns wkbNone.

This method is the same as the C function OGR_L_GetGeomType().

If this method is derived in a driver, it must be done such that it returns the same content as GetLayerDefn()->OGRFeatureDefn::GetGeomType().

Returns
  the geometry type

Since
  OGR 1.8.0

Reimplemented from OGRLayer.

OGRFeatureDefn * OGRUnionLayer::GetLayerDefn | ( |  | ) |
| virtual

Fetch the schema information for this layer.

The returned OGRFeatureDefn is owned by the OGRLayer, and should not be modified or freed by the application. It encapsulates the attribute schema of the features of the layer.

This method is the same as the C function OGR_L_GetLayerDefn().

Returns
  feature definition.

Implements OGRLayer.

virtual const char* OGRUnionLayer::GetName | ( |  | ) |
| inline virtual

Return the layer name.

This returns the same content as GetLayerDefn()->OGRFeatureDefn::GetName(), but for a few drivers, calling GetName() directly can avoid lengthy layer definition initialization.

This method is the same as the C function OGR_L_GetName().

If this method is derived in a driver, it must be done such that it returns the same content as GetLayerDefn()->OGRFeatureDefn::GetName().

Returns
  the layer name (must not been freed)

Since
  OGR 1.8.0

Reimplemented from OGRLayer.

OGRFeature * OGRUnionLayer::GetNextFeature | ( |  | ) |
| virtual

Fetch the next available feature from this layer.

The returned feature becomes the responsibility of the caller to delete with OGRFeature::DestroyFeature(). It is critical that all features associated with an OGRLayer (more specifically an OGRFeatureDefn) be deleted before that layer/datasource is deleted.

Only features matching the current spatial filter (set with SetSpatialFilter()) will be returned.

This method implements sequential access to the features of a layer. The ResetReading() method can be used to start at the beginning again.

Features returned by GetNextFeature() may or may not be affected by concurrent modifications depending on drivers. A guaranteed way of seeing modifications in effect is to call ResetReading() on layers where GetNextFeature() has been called, before reading again. Structural changes in layers (field addition, deletion, ...) when a read is in progress may or may not be possible depending on drivers. If a transaction is committed/aborted, the current sequential reading may or may not be valid after that operation and a call to ResetReading() might be needed.

This method is the same as the C function OGR_L_GetNextFeature().

Returns
  a feature, or NULL if no more features are available.

Implements OGRLayer.

OGRSpatialReference * OGRUnionLayer::GetSpatialRef | ( |  | ) |
| virtual

Fetch the spatial reference system for this layer.

The returned object is owned by the OGRLayer and should not be modified or freed by the application.

Starting with OGR 1.11, several geometry fields can be associated to a feature definition. Each geometry field can have its own spatial reference system, which is returned by OGRGeomFieldDefn::GetSpatialRef(). OGRLayer::GetSpatialRef() is equivalent to GetLayerDefn()->OGRFeatureDefn::GetGeomFieldDefn(0)->GetSpatialRef()

This method is the same as the C function OGR_L_GetSpatialRef().

Returns
  spatial reference, or NULL if there isn't one.

Reimplemented from OGRLayer.

OGRErr OGRUnionLayer::ICreateFeature | ( | OGRFeature * | poFeature | ) |
| virtual

Create and write a new feature within a layer.

This method is implemented by drivers and not called directly. User code should use CreateFeature() instead.

The passed feature is written to the layer as a new feature, rather than overwriting an existing one. If the feature has a feature id other than OGRNullFID, then the native implementation may use that as the feature id of the new feature, but not necessarily. Upon successful return the passed feature will have been updated with the new feature id.

Parameters

  poFeature | the feature to write to disk.

Returns
  OGRERR_NONE on success.

Since
  GDAL 2.0

Reimplemented from OGRLayer.

OGRErr OGRUnionLayer::ISetFeature | ( | OGRFeature * | poFeature | ) |
| virtual

Rewrite an existing feature.

This method is implemented by drivers and not called directly. User code should use SetFeature() instead.

This method will write a feature to the layer, based on the feature id within the OGRFeature.

Parameters

  poFeature | the feature to write.

Returns
  OGRERR_NONE if the operation works, otherwise an appropriate error code (e.g OGRERR_NON_EXISTING_FEATURE if the feature does not exist).

Since
  GDAL 2.0

Reimplemented from OGRLayer.

void OGRUnionLayer::ResetReading | ( |  | ) |
| virtual

Reset feature reading to start on the first feature.

This affects GetNextFeature().

This method is the same as the C function OGR_L_ResetReading().

Implements OGRLayer.

OGRErr OGRUnionLayer::SetAttributeFilter | ( | const char * | pszQuery | ) |
| virtual

Set a new attribute query.

This method sets the attribute query string to be used when fetching features via the GetNextFeature() method. Only features for which the query evaluates as true will be returned.

The query string should be in the format of an SQL WHERE clause. For instance "population > 1000000 and population < 5000000" where population is an attribute in the layer. The query format is normally a restricted form of SQL WHERE clause as described in the "WHERE" section of the OGR SQL tutorial. In some cases (RDBMS backed drivers) the native capabilities of the database may be used to interpret the WHERE clause in which case the capabilities will be broader than those of OGR SQL.

Note that installing a query string will generally result in resetting the current reading position (ala ResetReading()).

This method is the same as the C function OGR_L_SetAttributeFilter().

Parameters

  pszQuery | query in restricted SQL WHERE format, or NULL to clear the current query.

Returns
  OGRERR_NONE if successfully installed, or an error code if the query expression is in error, or some other failure occurs.

Reimplemented from OGRLayer.

OGRErr OGRUnionLayer::SetIgnoredFields | ( | const char ** | papszFields | ) |
| virtual

Set which fields can be omitted when retrieving features from the layer.

If the driver supports this functionality (testable using OLCIgnoreFields capability), it will not fetch the specified fields in subsequent calls to GetFeature() / GetNextFeature() and thus save some processing time and/or bandwidth.

Besides field names of the layers, the following special fields can be passed: "OGR_GEOMETRY" to ignore geometry and "OGR_STYLE" to ignore layer style.

By default, no fields are ignored.

This method is the same as the C function OGR_L_SetIgnoredFields()

Parameters

  papszFields | an array of field names terminated by NULL item. If NULL is passed, the ignored list is cleared.

Returns
  OGRERR_NONE if all field names have been resolved (even if the driver does not support this method)

Reimplemented from OGRLayer.

void OGRUnionLayer::SetSpatialFilter | ( | OGRGeometry * | poFilter | ) |
| virtual

Set a new spatial filter.

This method set the geometry to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the filter geometry will be returned.

Currently this test is may be inaccurately implemented, but it is guaranteed that all features who's envelope (as returned by OGRGeometry::getEnvelope()) overlaps the envelope of the spatial filter will be returned. This can result in more shapes being returned that should strictly be the case.

This method makes an internal copy of the passed geometry. The passed geometry remains the responsibility of the caller, and may be safely destroyed.

For the time being the passed filter geometry should be in the same SRS as the layer (as returned by OGRLayer::GetSpatialRef()). In the future this may be generalized.

This method is the same as the C function OGR_L_SetSpatialFilter().

Parameters

  poFilter | the geometry to use as a filtering region. NULL may be passed indicating that the current spatial filter should be cleared, but no new one instituted.

Reimplemented from OGRLayer.

void OGRUnionLayer::SetSpatialFilter | ( | int | iGeomField,
|  | OGRGeometry * | poFilter
| ) |  |
| virtual

Set a new spatial filter.

This method set the geometry to be used as a spatial filter when fetching features via the GetNextFeature() method. Only features that geometrically intersect the filter geometry will be returned.

Currently this test is may be inaccurately implemented, but it is guaranteed that all features who's envelope (as returned by OGRGeometry::getEnvelope()) overlaps the envelope of the spatial filter will be returned. This can result in more shapes being returned that should strictly be the case.

This method makes an internal copy of the passed geometry. The passed geometry remains the responsibility of the caller, and may be safely destroyed.

For the time being the passed filter geometry should be in the same SRS as the geometry field definition it corresponds to (as returned by GetLayerDefn()->OGRFeatureDefn::GetGeomFieldDefn(iGeomField)->GetSpatialRef()). In the future this may be generalized.

Note that only the last spatial filter set is applied, even if several successive calls are done with different iGeomField values.

Note to driver implementer: if you implement SetSpatialFilter(int,OGRGeometry*), you must also implement SetSpatialFilter(OGRGeometry*) to make it call SetSpatialFilter(0,OGRGeometry*).

This method is the same as the C function OGR_L_SetSpatialFilterEx().

Parameters

  iGeomField | index of the geometry field on which the spatial filter operates.
  poFilter | the geometry to use as a filtering region. NULL may be passed indicating that the current spatial filter should be cleared, but no new one instituted.

Since
  GDAL 1.11

Reimplemented from OGRLayer.

OGRErr OGRUnionLayer::SyncToDisk | ( |  | ) |
| virtual

Flush pending changes to disk.

This call is intended to force the layer to flush any pending writes to disk, and leave the disk file in a consistent state. It would not normally have any effect on read-only datasources.

Some layers do not implement this method, and will still return OGRERR_NONE. The default implementation just returns OGRERR_NONE. An error is only returned if an error occurs while attempting to flush to disk.

In any event, you should always close any opened datasource with OGRDataSource::DestroyDataSource() that will ensure all data is correctly flushed.

This method is the same as the C function OGR_L_SyncToDisk().

Returns
  OGRERR_NONE if no error occurs (even if nothing is done) or an error code.

Reimplemented from OGRLayer.

int OGRUnionLayer::TestCapability | ( | const char * | pszCap | ) |
| virtual

Test if this layer supported the named capability.

The capability codes that can be tested are represented as strings, but #defined constants exists to ensure correct spelling. Specific layer types may implement class specific capabilities, but this can't generally be discovered by the caller.

- OLCRandomRead / "RandomRead": TRUE if the GetFeature() method is implemented in an optimized way for this layer, as opposed to the default implementation using ResetReading() and GetNextFeature() to find the requested feature id.

- OLCSequentialWrite / "SequentialWrite": TRUE if the CreateFeature() method works for this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCRandomWrite / "RandomWrite": TRUE if the SetFeature() method is operational on this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCFastSpatialFilter / "FastSpatialFilter": TRUE if this layer implements spatial filtering efficiently. Layers that effectively read all features, and test them with the OGRFeature intersection methods should return FALSE. This can be used as a clue by the application whether it should build and maintain its own spatial index for features in this layer.

- OLCFastFeatureCount / "FastFeatureCount": TRUE if this layer can return a feature count (via GetFeatureCount()) efficiently. i.e. without counting the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastGetExtent / "FastGetExtent": TRUE if this layer can return its data extent (via GetExtent()) efficiently, i.e. without scanning all the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastSetNextByIndex / "FastSetNextByIndex": TRUE if this layer can perform the SetNextByIndex() call efficiently, otherwise FALSE.

- OLCCreateField / "CreateField": TRUE if this layer can create new fields on the current layer using CreateField(), otherwise FALSE.

- OLCCreateGeomField / "CreateGeomField": (GDAL >= 1.11) TRUE if this layer can create new geometry fields on the current layer using CreateGeomField(), otherwise FALSE.

- OLCDeleteField / "DeleteField": TRUE if this layer can delete existing fields on the current layer using DeleteField(), otherwise FALSE.

- OLCReorderFields / "ReorderFields": TRUE if this layer can reorder existing fields on the current layer using ReorderField() or ReorderFields(), otherwise FALSE.

- OLCAlterFieldDefn / "AlterFieldDefn": TRUE if this layer can alter the definition of an existing field on the current layer using AlterFieldDefn(), otherwise FALSE.

- OLCDeleteFeature / "DeleteFeature": TRUE if the DeleteFeature() method is supported on this layer, otherwise FALSE.

- OLCStringsAsUTF8 / "StringsAsUTF8": TRUE if values of OFTString fields are assured to be in UTF-8 format. If FALSE the encoding of fields is uncertain, though it might still be UTF-8.

- OLCTransactions / "Transactions": TRUE if the StartTransaction(), CommitTransaction() and RollbackTransaction() methods work in a meaningful way, otherwise FALSE.

- OLCIgnoreFields / "IgnoreFields": TRUE if fields, geometry and style will be omitted when fetching features as set by SetIgnoredFields() method.

- OLCCurveGeometries / "CurveGeometries": TRUE if this layer supports writing curve geometries or may return such geometries. (GDAL 2.0).

This method is the same as the C function OGR_L_TestCapability().

Parameters

  pszCap | the name of the capability to test.

Returns
  TRUE if the layer has the requested capability, or FALSE otherwise. OGRLayers will return FALSE for any unrecognized capabilities.

Implements OGRLayer.

The documentation for this class was generated from the following files:

- ogrunionlayer.h
- ogrunionlayer.cpp

Generated for GDAL by 1.8.8.